/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SENF                                                     */
/* Tabela : SERIENF                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SENF'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SENF
GO

CREATE TRIGGER DTULTATU_SENF
ON SERIENF
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SERIENF', null,'CDEMPRESA=' + CDEMPRESA + ';' +
                                     'CDINSCESTA='+ CDINSCESTA+ ';'+
                                     'CDINSCMUNI='+ CDINSCMUNI+ ';'+
                                     'CDSERIE='   + CDSERIE   + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SERIENF
      SET DTULTATUSENF = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(SERIENF.CDSERIE,0)     = ISNULL(INSERTED.CDSERIE,0))             AND
            (ISNULL(SERIENF.DSSERIE,0)     = ISNULL(INSERTED.DSSERIE,0))             AND
            (ISNULL(SERIENF.CDEMPRESA,0)   = ISNULL(INSERTED.CDEMPRESA,0))           AND
            (ISNULL(SERIENF.CDINSCESTA,0)  = ISNULL(INSERTED.CDINSCESTA,0))          AND
            (ISNULL(SERIENF.DTULTATUSENF,CONVERT(DATETIME,'31/12/1899'))=
            ISNULL(INSERTED.DTULTATUSENF,CONVERT(DATETIME,'31/12/1899')))            AND
            (ISNULL(SERIENF.CDRELMODENF,0) = ISNULL(INSERTED.CDRELMODENF,0))         AND
            (ISNULL(SERIENF.CDRELESPENF,0) = ISNULL(INSERTED.CDRELESPENF,0))         AND
            (ISNULL(SERIENF.NRMAXITNF,0)   = ISNULL(INSERTED.NRMAXITNF,0))           AND
            (ISNULL(SERIENF.CDINSCMUNI,0)  = ISNULL(INSERTED.CDINSCMUNI,0))          AND
            (ISNULL(SERIENF.CDCTRLNUMENF,0)= ISNULL(INSERTED.CDCTRLNUMENF,0))        AND
            (ISNULL(SERIENF.NRMAXSERVNF,0) = ISNULL(INSERTED.NRMAXSERVNF,0))         AND
            (ISNULL(SERIENF.IDCONMAXITEM,0)= ISNULL(INSERTED.IDCONMAXITEM,0))        AND
            (ISNULL(SERIENF.IDUTDTPREMIS,0)= ISNULL(INSERTED.IDUTDTPREMIS,0))        AND
            (ISNULL(SERIENF.CDSERIENFE, 0) = ISNULL(INSERTED.CDSERIENFE, 0))         AND
            (ISNULL(SERIENF.CDSERIENFESCAN, 0) = ISNULL(INSERTED.CDSERIENFESCAN, 0)) AND
            (ISNULL(SERIENF.CDCTRLNUMENFC, 0)  = ISNULL(INSERTED.CDCTRLNUMENFC, 0));
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_SENF','5.30.xxx';
GO

